
angular.module('ag561app').controller('ProvisionController', ['$http', '$log',
                                   function($http, $log,) {

  var ctrl = this;
  ctrl.loading = false;
  ctrl.invalid_config = false;
  ctrl.alert_success = false;
  ctrl.alert_error = false;

  /**
   * Get provisioning config parameters.
   * @function get
   * @memberof ProvisionController
   */
  ctrl.get = function() {
    ctrl.loading = true;
    $http.get('/api/config/provision')
      .then(function(response) {
        // First function handles success
        ctrl.provision = response.data;
        ctrl.loading = false;
      });
  }

  /**
   * Save the new configuration.
   * @function save
   * @memberof NetworkController
   */
  ctrl.save = function() {
    ctrl.loading = true;
    // PUT data to API
    $http({
      method: 'PUT',
      url: '/api/config/provision',
      data: ctrl.provision,
      }).then(function(response) {
          // First function handles success
          ctrl.loading = false;
          ctrl.alert_success = true;
          ctrl.get();
      }, function(response) {
          // Second function handles error
          ctrl.error = response.data;
          ctrl.alert_error = true;
      });
  };

  ctrl.get();

  ctrl.check_config = function() {
    // Validate baseurl
    var url_format = new RegExp("^(http|ftp|tftp)://[A-Za-z0-9_\./@:\-]+/$");
    ctrl.invalid_baseurl = !ctrl.provision.baseurl.match(url_format);
    
    ctrl.invalid_config = ctrl.invalid_baseurl;
  };

}]);

